Subject: Re: [RFC] Disable lockref on arm64

From: Kees Cook <[email-masked]>
Date: Sun, 16 Jun 2019 14:31:24 -0700

On Sat, Jun 15, 2019 at 04:18:21PM +0200, Ard Biesheuvel wrote:
> Yes, I am using the same saturation point as x86. In this example, I
> am not entirely sure I understand why it matters, though: the atomics
> guarantee that the write by CPU2 fails if CPU1 changed the value in
> the mean time, regardless of which value it wrote.
> 
> I think the concern is more related to the likelihood of another CPU
> doing something nasty between the moment that the refcount overflows
> and the moment that the handler pins it at INT_MIN/2, e.g.,
> 
> > CPU 1                   CPU 2
> > inc()
> >   load INT_MAX
> >   about to overflow?
> >   yes
> >
> >   set to 0
> >                          <insert exploit here>
> >   set to INT_MIN/2

Ah, gotcha, but the "set to 0" is really "set to INT_MAX+1" (not zero)
if you're using the same saturation.

-- 
Kees Cook

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel